package es.claro.persistence;

import java.util.Map;

import javax.persistence.EntityManager;
import javax.persistence.EntityManagerFactory;

public class LazyScopedEntityManagerFactory extends ScopedEntityManagerFactory {

   protected LazyScopedEntityManagerFactory(final EntityManagerFactory emf) {
      super(emf);
   }

   @Override
   public EntityManager createEntityManager(final Map map) {
      return new LazyCloseEntityManager(super.createEntityManager(map));
   }

   @Override
   public EntityManager createEntityManager() {
      return new LazyCloseEntityManager(super.createEntityManager());
   }

   @Override
   protected void createEntityManager(final EntityManagerProxy em) {
      super.createEntityManager(em);
      ((LazyCloseEntityManager) em).setLazyCloseListener(this);
   }

   @Override
   protected LazyCloseEntityManager getEntityManager() {
      return (LazyCloseEntityManager) super.getEntityManager();
   }

}
