package es.claro.persistence;

import javax.servlet.ServletRequestEvent;
import javax.servlet.ServletRequestListener;

/**
 * 
 * @author puche
 * 
 *         Web application lifecycle listener.
 */

public class PersistenceAppRequestListener extends PersistenceAppListener implements ServletRequestListener {

   /**
    * ### Method from ServletRequestListener ###
    * 
    * The request is about to come into scope of the web application.
    */
   public void requestInitialized(final ServletRequestEvent evt) {

   }

   /**
    * ### Method from ServletRequestListener ###
    * 
    * The request is about to go out of scope of the web application.
    */
   public void requestDestroyed(final ServletRequestEvent evt) {

      final PersistenceManager pm = PersistenceManager.getInstance();

      if (pm instanceof ScopedPersistenceManager) {
         final LazyCloseEntityManager em = (LazyCloseEntityManager) ((ScopedEntityManagerFactory) pm
               .getEntityManagerFactory()).getEntityManager();

         // solo si ya exist�a se cierra, pero es posible que no exista
         if (em != null) {
            em.lazyClose();
         }
      }
   }
}